// Memory allocation test code
//
// Copyright (c) David Drysdale 2001
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
// AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
// Except as contained in this notice, the name of the author shall not be
// used in advertising or otherwise to promote the sale, use or other dealings
// in this Software without prior written authorization from the author.

#define DEBUG
#define TRCCLASSNAME "testmem"
#include <cpptrace.h>
#include <debugmem.h>

class C {
public:
  C() {
    TRACE_FN("C");
    TRC_NRM("Construct C at "<<this);
  }
  ~C() {
    TRACE_FN("C");
    TRC_NRM("Destruct C at "<<this);
  }
  int a;
  int b;
};

int main()
{
  TRACE_FN("main");
  C *pC1;
  C *pC2;
  C *pC3;
  int *pI;

  pC1 = NEW C;
  DELETE(pC1);
  TRC_ALT("double delete of "<<pC1);
  DELETE(pC1); // double delete

  pC2 = NEW C;
  pI = reinterpret_cast<int *>(pC2);
  pI[0] = 1;
  pI[1] = 2;
  pI[2] = 3; // overwrite end of memory
  TRC_ALT("guard byte overwritten on "<<pC2);
  DELETE(pC2);

  pC3 = NEW C; // this will be leaked
  TRC_ALT("going to leak "<<pC3);

  return 0;
}
