// Test program for C++ trace functionality
//
// Copyright (c) David Drysdale 2000
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
// AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
// Except as contained in this notice, the name of the author shall not be
// used in advertising or otherwise to promote the sale, use or other dealings
// in this Software without prior written authorization from the author.

#define TRCCLASSNAME "TestClass"

#include <unistd.h>

#include <cpptrace.h>

class TestClass {
public:
  void longMethodName(const char*str);
  void f(int a);
};

void TestClass::longMethodName(const char*str)
{
  TRACE_FN("longMethodName");
  TRC_ALT("in this method, the string is :"<<str<<":");
}

void TestClass::f(int a)
{
  TRACE_FN("f");
  TRC_DBG("value of a is "<<a);
}

int main()
{
  TRACE_FN("main");
  TRC_LOG("Now start up main()");
  TestClass c;
  c.f(1);
  c.longMethodName("A String of Mixed Case");
  for (int ii=0; ii<8; ii++) {
    TRC_DBG("debug level trace");
    TRC_NRM("normal level trace");
    TRC_ALT("alert level trace");
    TRC_ERR("error level trace");
    sleep(1);
  }
  // TRC_ASSERT((0==1),"zero is not one!");
  TRC_LOG("time to go");
  return 0;
}
